/*! For license information please see plugin_kansuji.js.LICENSE.txt */
(function(){"use strict";var __webpack_modules__={"./src/plugin_kansuji.mjs":function(__unused_webpack___webpack_module__,__webpack_exports__,__webpack_require__){eval("__webpack_require__.r(__webpack_exports__);\n// @ts-nocheck\nconst PluginKansuji = {\n\n  '初期化': {\n    type: 'func',\n    josi: [],\n    pure: true,\n    fn: function (sys) {\n    }\n  },\n\n  // @漢数字関連\n  '漢数字': { // @引数を数字と解釈して漢数字の文字列を返す // @かんすうじ\n    type: 'func',\n    josi: [['を', 'の']],\n    pure: true,\n    fn: function (input) {\n      function preprocesser (input) {\n        // eslint-disable-next-line camelcase\n        function if_number_is_exponent (input) {\n          const match = input.match(/[0-9]*\\.?[0-9]+[eE][-+]?[0-9]+/)\n          if (match && match[0] === input) {\n            const base = input.match(/[0-9]*\\.?[0-9]+[eE]/)[0].slice(0, -1)\n            const exponent = input.match(/[eE][-+]?[0-9]+/)[0].slice(1)\n            // eslint-disable-next-line no-inner-declarations\n            function movepoint (base, exponent) {\n              const sign = exponent[0]\n              const curpointidx = base.includes('.') ? base.indexOf('.') : base.length\n              const idx = sign === '-' ? curpointidx - parseInt(exponent.slice(1)) : curpointidx + parseInt(exponent.match(/[0-9]+$/)[0])\n              function strIns (str, idx, val) {\n                return str.slice(0, idx) + val + str.slice(idx)\n              }\n              if (idx > 0) {\n                if (base.length - curpointidx > idx) {\n                  return strIns(base.replace('.', ''), idx, '.')\n                } else {\n                  if (base.includes('.')) {\n                    return base.replace('.', '') + '0'.repeat(idx - base.length + curpointidx)\n                  } else {\n                    return base + '0'.repeat(idx - base.length + curpointidx - 1)\n                  }\n                }\n              } else {\n                return '0.' + '0'.repeat(-idx) + base.replace('.', '')\n              }\n            }\n            input = movepoint(base, exponent)\n          }\n          return input\n        }\n        function asciify (input) { // 全角数字を半角数字に\n          return input.replace(/[０-９]/g, s => {\n            return String.fromCharCode(s.charCodeAt(0) - 65248)\n          })\n        }\n        input = asciify(input)\n        if (Number.isNaN(Number(input))) { throw new Error('『漢数字』命令の中に無効な文字が含まれています。') }\n        const output = if_number_is_exponent(input.toString())\n        // eslint-disable-next-line no-loss-of-precision\n        if (output > BigInt(999999999999999999999999999999999999999999999999999999999999999999999999)) { throw new Error('『漢数字』命令の中に含められる数の大きさを超えています。') }\n        return output\n      }\n      input = preprocesser(String(input))\n      function separater (str) {\n        let isminus = str.includes('.')\n        return str.split('').reverse().reduce((acc, cur) => {\n          if (cur === '.') {\n            isminus = false\n            acc.splice(1, 0, '.')\n            return acc\n          } else if (isminus) {\n            acc.splice(1, 0, cur)\n            return acc\n          }\n          if (acc[0].length === 軸数字.length) {\n            acc.unshift([])\n          }\n          acc[0].unshift(cur)\n          return acc\n        }, [[]])\n      }\n      function converter (arr) {\n        function replacer (str) {\n          return 基本漢数字[基本算用数字.indexOf(str)]\n        }\n        let adjuster = 0\n        const result = arr.reverse().reduce((acc, cur, idx) => {\n          if (typeof cur === 'string') {\n            if (cur === '.') {\n              acc = '・' + acc\n              adjuster = idx + 1\n            } else {\n              acc = replacer(cur) + acc\n            }\n          } else {\n            const unit = cur.reduce((acc, cur, idx, src) => {\n              if (cur === '0') {\n                return acc\n              } else if (cur === '1' && 軸数字[src.length - 1 - idx] !== '') {\n                return acc + 軸数字[src.length - 1 - idx]\n              } else {\n                return acc + replacer(cur) + 軸数字[src.length - 1 - idx]\n              }\n            }, '')\n            acc = (unit ? unit + 単位数字[idx - adjuster] : '') + acc\n          }\n          return acc\n        }, '')\n        return result[0] === '・' ? '零' + result : result\n      }\n      // フラグを覚えておく #874\n      let flag = ''\n      if (input.charAt(0) === '+' || input.charAt(0) === '-') {\n        flag = input.charAt(0)\n        input = input.substr(1)\n      }\n      let res = converter(separater(input))\n      if (res === '') { res = '零' }\n      return flag + res\n    }\n  },\n  '算用数字': { // @U引数を漢数字と解釈して数値を返す // @さんようすうじ\n    type: 'func',\n    josi: [['を', 'の']],\n    pure: true,\n    fn: function (input) {\n      function converter (src) {\n        const multibytes = 単位数字.filter(a => a.length > 1)\n        const result = []\n        for (let idx = 0; idx < src.length; idx++) {\n          const cur = src.slice(idx, idx + 1)\n          const 指数 = 単位数字.includes(cur) ? cur : multibytes.find(v => v === src.slice(idx, idx + v.length))\n          const 位 = 軸数字.includes(cur) ? cur : null\n          const 底 = 基本漢数字.includes(cur) ? cur : null\n          if (指数) {\n            if (指数.length > 1) {\n              idx += 指数.length - 1\n            }\n            result.push(BigInt('1' + '0'.repeat(4 * 単位数字.indexOf(指数))))\n          } else if (位) {\n            result.push(10 ** (軸数字.indexOf(位)))\n          } else if (底) {\n            result.push(基本漢数字.indexOf(底))\n          } else if (cur === '・') {\n            result.push('.')\n          } else if (cur === '零') {\n            result.push('0')\n          } else {\n            throw new Error('『算用数字』命令の中に無効な文字が含まれています。')\n          }\n        }\n        return result\n      }\n      function separater (arr) {\n        let base = []\n        let unit = []\n        let isminus = false\n        return arr.reduce((acc, cur, idx) => {\n          if (cur === '.') {\n            if (base.length === 0) { base.push(0, 1) }\n            if (base.length === 1) { base.push(1) }\n            unit.push(base)\n            base = []\n            acc.push(unit)\n            acc.push('.')\n            unit = []\n            isminus = true\n          } else if (isminus) {\n            acc.push(String(cur))\n          } else if (cur > 1000) {\n            if (base.length === 0) { base.push(0, 1) }\n            if (base.length === 1) { base.push(1) }\n            unit.push(base)\n            base = []\n            unit.push(cur)\n            acc.push(unit)\n            unit = []\n          } else if (cur >= 10 && cur <= 1000) {\n            if (base.length === 0) { base.push(1) }\n            base.push(cur)\n            unit.push(base)\n            base = []\n          } else if (cur < 10) {\n            base.push(cur)\n          }\n          if (idx + 1 === arr.length && isminus === false) {\n            if (base.length === 1) {\n              base.push(1)\n              unit.push(base)\n            }\n            acc.push(unit)\n          }\n          return acc\n        }, [])\n      }\n      function calculator (arr) {\n        return arr.reduce((acc, cur, idx) => {\n          return typeof cur === 'string'\n            ? acc + cur\n            : acc + cur.reduce((acc, cur, idx) => {\n              return cur > 1000 ? acc * cur : acc + BigInt(cur[0] * cur[1])\n            }, BigInt(0))\n        }, BigInt(0))\n      }\n      const tmp = calculator(separater(converter(input.toString())))\n      return tmp > Number.MAX_SAFE_INTEGER ? tmp : Number(tmp)\n    }\n  }\n}\n\nconst 単位数字 = [\n  '', '万', '億', '兆', '京', '垓', '𥝱', '穣', '溝', '澗', '正',\n  '載', '極', '恒河沙', '阿僧祇', '那由他', '不可思議', '無量大数'\n]\nconst 軸数字 = [\n  '', '十', '百', '千'\n]\nconst 基本算用数字 = '0123456789'.split('')\nconst 基本漢数字 = '〇一二三四五六七八九'.split('')\n\n/* harmony default export */ __webpack_exports__[\"default\"] = (PluginKansuji);\n\n// scriptタグで取り込んだ時、自動で登録する\nif (typeof (navigator) === 'object' && typeof (navigator.nako3) === 'object') { navigator.nako3.addPluginObject('PluginKansuji', PluginKansuji) }\n\n\n//# sourceURL=webpack://nadesiko3/./src/plugin_kansuji.mjs?")}},__webpack_require__={r:function(n){"undefined"!=typeof Symbol&&Symbol.toStringTag&&Object.defineProperty(n,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(n,"__esModule",{value:!0})}},__webpack_exports__={};__webpack_modules__["./src/plugin_kansuji.mjs"](0,__webpack_exports__,__webpack_require__)})();