/*! For license information please see plugin_webworker.js.LICENSE.txt */
(function(){"use strict";var __webpack_modules__={"./src/plugin_webworker.mjs":function(__unused_webpack___webpack_module__,__webpack_exports__,__webpack_require__){eval("__webpack_require__.r(__webpack_exports__);\n// @ts-nocheck\nconst PluginWebWorker = {\n  '初期化': {\n    type: 'func',\n    josi: [],\n    pure: true,\n    fn: function (sys) {\n      sys._webworker = {\n        setNakoHandler: function (work) {\n          work.onmessage = (event) => {\n            const data = event.data || { type: '', data: '' }\n            const type = data.type || ''\n            const value = data.data || ''\n            switch (type) {\n              case 'output':\n                if (work.onoutput) {\n                  work.onoutput.apply(sys, [value, event])\n                }\n                break\n              case 'data':\n                if (work.ondata) {\n                  work.ondata.apply(sys, [value, event])\n                }\n                break\n              case 'error':\n                sys.logger.error(value.noColor)\n                break\n            }\n          }\n          work.onerror = (event) => {\n            const e = new Error(typeof event.message !== 'undefined' ? event.message : 'no message')\n            sys.logger.error(e)\n          }\n          work.onerrormessage = (event) => {\n            const e = new Error(typeof event.message !== 'undefined' ? event.message : 'no message')\n            sys.logger.error(e)\n          }\n        },\n        inWorker: () => {\n          // eslint-disable-next-line no-undef\n          return typeof WorkerGlobalScope !== 'undefined' && self instanceof WorkerGlobalScope\n        },\n        getBaseUrlFromTag: () => {\n          if (!self.document) { return '' }\n          const pluginName = 'plugin_webworker.js'\n          let path = location.pathname\n          if (path.substr(path.length - 1, 1) !== '/') {\n            const paths = path.split('/')\n            path = paths.slice(paths.length - 1, 1).join('/') & '/'\n          }\n          const scripts = document.querySelectorAll('script')\n          for (let i = 0; i < scripts.length; i++) {\n            const script = scripts[i]\n            let src = script.src || ''\n            const index = src.indexOf(pluginName)\n            if (index >= 0) {\n              if (src.length - index === pluginName.length ||\n                  '?&#'.indexOf(src.substr(index + pluginName.length, 1)) >= 0) {\n                src = src.substring(0, index)\n                if (src.substring(0, 1) === '/') {\n                  // スクリプトソースはorigin無しの絶対パス\n                  return location.origin + src\n                }\n                if (/^[a-zA-Z]+:\\/\\//.test(src)) {\n                  // スクリプトソースは絶対URI\n                  return src\n                }\n                // スクリプトソースはorigin無しの相対パス\n                return location.origin + path + src\n              }\n            }\n          }\n          // スクリプトソースが見つからなかったのでドキュメントのURIを返す\n          return location.origin + path\n        }\n      }\n      sys.__v0['ワーカーURL'] = sys._webworker.getBaseUrlFromTag()\n    }\n  },\n  // @イベント定数\n  '対象イベント': { type: 'const', value: '' }, // @たいしょういべんと\n  '受信データ': { type: 'const', value: '' }, // @たいしょういべんと\n\n  'ワーカーURL': { type: 'const', value: '' }, // @わーかーURL\n  'ワーカーURL設定': { // @なでしこv3のファイルのあるURLを設定 // @わーかーURLせってい\n    type: 'func',\n    josi: [['に', 'へ', 'と']],\n    pure: true,\n    fn: function (url, sys) {\n      if (url && url.substring(url.length - 1) !== '/') {\n        url += '/'\n      }\n      sys.__v0['ワーカーURL'] = url\n    },\n    return_none: true\n  },\n\n  // @NAKOワーカー\n  'ワーカー起動': { // @指定したURLでWebWorkerを起動する。ワーカオブジェクトを返す。 // @わーかーきどう\n    type: 'func',\n    josi: [['で', 'を', 'の']],\n    pure: true,\n    fn: function (url, sys) {\n      return new Worker(url)\n    },\n    return_none: false\n  },\n  'ワーカーJS起動': { // @指定したJavascriptのソースでWebWorkerを起動する。ワーカオブジェクトを返す。 // @わーかーJSきどう\n    type: 'func',\n    josi: [['で', 'を', 'の']],\n    pure: true,\n    fn: function (src, sys) {\n      const blob = new Blob([src], { type: 'application/javascript' })\n      const url = URL.createObjectURL(blob)\n      return new Worker(url)\n    },\n    return_none: false\n  },\n  'NAKOワーカー起動': { // @指定したなでしこ３のWebWorkerを起動する。ワーカオブジェクトを返す。 // @NAKOわーかーきどう\n    type: 'func',\n    josi: [['で']],\n    isVariableJosi: true,\n    pure: true,\n    fn: function (plugins, sys) {\n      let url\n      if (typeof sys === 'undefined') { sys = plugins; plugins = undefined }\n      if (plugins !== undefined) {\n        if (!(plugins instanceof Array)) {\n          throw new Error('プラグインはファイル名を配列で指定してください')\n        }\n        const baseurl = sys.__v0['ワーカーURL']\n        let code = `importScripts('${baseurl}wnako3webworker.js')\\n`\n        const l = plugins.length\n        let i\n        for (i = 0; i < l; i++) {\n          code += `importScripts('${baseurl}${plugins[i]}')\\n`\n        }\n        const blob = new Blob([code], { type: 'application/javascript' })\n        url = URL.createObjectURL(blob)\n      } else {\n        url = sys.__v0['ワーカーURL'] + 'wnako3webworker.js'\n      }\n      const myWorker = new Worker(url)\n      if (myWorker) {\n        sys._webworker.setNakoHandler(myWorker)\n      }\n      return myWorker\n    },\n    return_none: false\n  },\n  'NAKOワーカーハンドラ設定': { // @ワーカーにNAKOワーカーのための設定を行う。 // @NAKOわーかーはんどらせってい\n    type: 'func',\n    josi: [['に', 'へ', 'の']],\n    pure: true,\n    fn: function (work, sys) {\n      sys._webworker.setNakoHandler(work)\n    },\n    return_none: true\n  },\n  'NAKOワーカーデータ受信時': { // @無名関数Fでなでしこv3エンジンに対してワーカーメッセージによりデータを受信した時に実行するイベントを設定。『受信データ』に受信したデータ。『対象イベント』にイベント引数。 // @NAKOわーかーでーたじゅしんしたとき\n    type: 'func',\n    josi: [['で'], ['から']],\n    isVariableJosi: true,\n    pure: false,\n    fn: function (func, work, sys) {\n      if (typeof sys === 'undefined') { sys = work; work = self }\n      func = sys.__findVar(func, null) // 文字列指定なら関数に変換\n      work.ondata = (data, e) => {\n        sys.__v0['受信データ'] = data\n        sys.__v0['対象イベント'] = e\n        return func(e, sys)\n      }\n    },\n    return_none: true\n  },\n  'NAKOワーカー表示時': { // @無名関数Fでなでしこv3エンジンに対してワーカーメッセージにより表示データを受信した時に実行するイベントを設定。『受信データ』に表示しようとしたデータ。『対象イベント』にイベント引数。 // @NAKOわーかーひょうじしたとき\n    type: 'func',\n    josi: [['で'], ['から']],\n    pure: false,\n    fn: function (func, work, sys) {\n      func = sys.__findVar(func, null) // 文字列指定なら関数に変換\n      work.onoutput = (data, e) => {\n        sys.__v0['受信データ'] = data\n        sys.__v0['対象イベント'] = e\n        return func(e, sys)\n      }\n    },\n    return_none: true\n  },\n  'ワーカーメッセージ受信時': { // @無名関数Fでworkに対してメッセージを受信した時に実行するイベントを設定。『受信データ』に受信したデータ。『対象イベント』にイベント引数。 // @わーかーめっせーじじゅしんしたとき\n    type: 'func',\n    josi: [['で'], ['から']],\n    isVariableJosi: true,\n    pure: false,\n    fn: function (func, work, sys) {\n      if (typeof sys === 'undefined') { sys = work; work = self }\n      func = sys.__findVar(func, null) // 文字列指定なら関数に変換\n      work.onmessage = (e) => {\n        sys.__v0['受信データ'] = e.data\n        sys.__v0['対象イベント'] = e\n        return func(e, sys)\n      }\n    },\n    return_none: true\n  },\n  'NAKOワーカープログラム起動': { // @WORKERに固有の形式でプログラムの転送と実行行う。 // @NAKOわーかーぷろぐらむきどう\n    type: 'func',\n    josi: [['に', 'で'], ['を']],\n    pure: true,\n    fn: function (work, data, sys) {\n      const msg = {\n        type: 'run',\n        data: sys.__modName + '__' + data\n      }\n      work.postMessage(msg)\n    },\n    return_none: true\n  },\n  'NAKOワーカーリセット': { // @WORKERに固有の形式でプログラムの転送と実行行う。 // @わーかーりせっと\n    type: 'func',\n    josi: [['を']],\n    pure: true,\n    fn: function (work, sys) {\n      const msg = {\n        type: 'reset',\n        data: ''\n      }\n      work.postMessage(msg)\n    },\n    return_none: true\n  },\n  'ワーカー終了': { // @WORKERを終了する。 // @わーかーしゅうりょう\n    type: 'func',\n    josi: [['を']],\n    isVariableJosi: true,\n    pure: true,\n    fn: function (work, sys) {\n      if (typeof sys === 'undefined') { sys = work; work = self }\n      work.terminate()\n    },\n    return_none: true\n  },\n  'NAKOワーカー終了': { // @WORKERを終了する。 // @NAKOわーかーしゅうりょう\n    type: 'func',\n    josi: [['を']],\n    isVariableJosi: true,\n    pure: true,\n    fn: function (work, sys) {\n      if (typeof sys === 'undefined') {\n        self.close()\n        return\n      }\n      const msg = {\n        type: 'close',\n        data: ''\n      }\n      work.postMessage(msg)\n    },\n    return_none: true\n  },\n  'NAKOワーカーデータ送信': { // @WORKERに固有の形式でデータを送信する。 // @NAKOわーかーでーたそうしん\n    type: 'func',\n    josi: [['を'], ['に', 'へ']],\n    isVariableJosi: true,\n    pure: true,\n    fn: function (data, work, sys) {\n      if (typeof sys === 'undefined') { sys = work; work = self }\n      const msg = {\n        type: 'data',\n        data: data\n      }\n      work.postMessage(msg)\n    },\n    return_none: true\n  },\n  'ワーカーメッセージ送信': { // @WORKERにメッセージを送信する。 // @わーかーめっせーじそうしん\n    type: 'func',\n    josi: [['を'], ['に', 'へ']],\n    isVariableJosi: true,\n    pure: true,\n    fn: function (msg, work, sys) {\n      if (typeof sys === 'undefined') { sys = work; work = self }\n      work.postMessage(msg)\n    },\n    return_none: true\n  },\n  'NAKOワーカー転送': { // @WORKERにユーザー定義関数またはユーザ定義のグローバル変数を転送する。 // @NAKOわーかーてんそう\n    type: 'func',\n    josi: [['を'], ['に', 'へ']],\n    isVariableJosi: true,\n    pure: false,\n    fn: function (datas, work, sys) {\n      if (typeof sys === 'undefined') { sys = work; work = self }\n      const obj = []\n      if (typeof datas === 'string') { datas = [datas] }\n      datas.forEach(data => {\n        data = sys.__modName + '__' + data\n        if (typeof sys.__varslist[2][data] !== 'undefined') {\n          obj.push({\n            type: 'val',\n            name: data,\n            content: sys.__varslist[2][data]\n          })\n        } else\n        if (typeof sys.__varslist[1][data] !== 'undefined') {\n          obj.push({\n            type: 'func',\n            name: data,\n            content: {\n              meta: sys.gen.nakoFuncList[data],\n              func: Object.assign({}, sys.compiler.funclist[data], { fn: null })\n            }\n          })\n        } else {\n          console.error('指定した名前のユーザ関数もしくはグローバル変数がありません:' + data)\n          throw new Error('指定した名前のユーザ関数もしくはグローバル変数がありません:' + data)\n        }\n      })\n      if (obj.length > 0) {\n        const msg = {\n          type: 'trans',\n          data: obj\n        }\n        work.postMessage(msg)\n      }\n    },\n    return_none: true\n  }\n}\n\n/* harmony default export */ __webpack_exports__[\"default\"] = (PluginWebWorker);\n\nif (typeof (navigator) === 'object' && typeof (navigator.nako3) === 'object') {\n  navigator.nako3.addPluginObject('PluginWebWorker', PluginWebWorker)\n}\n\n\n\n//# sourceURL=webpack://nadesiko3/./src/plugin_webworker.mjs?")}},__webpack_require__={r:function(n){"undefined"!=typeof Symbol&&Symbol.toStringTag&&Object.defineProperty(n,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(n,"__esModule",{value:!0})}},__webpack_exports__={};__webpack_modules__["./src/plugin_webworker.mjs"](0,__webpack_exports__,__webpack_require__)})();