/*! For license information please see plugin_weykturtle3d.js.LICENSE.txt */
(function(){"use strict";var __webpack_modules__={"./src/plugin_weykturtle3d.mjs":function(__unused_webpack___webpack_module__,__webpack_exports__,__webpack_require__){eval("__webpack_require__.r(__webpack_exports__);\n// @ts-nocheck\n/**\n * PluginWeykTurtle3D\n */\nlet THREE = window.THREE\n\nconst PluginWeykTurtle3D = {\n  '初期化': {\n    type: 'func',\n    josi: [],\n    pure: true,\n    fn: function (sys) {\n      if (sys._weykturtle3d) { return }\n      if (typeof window.THREE === 'undefined') {\n        throw new Error('three.jsが読み込まれていません')\n      }\n      THREE = window.THREE // set three.js instance\n      sys._weykturtle3d = {\n        containerid: '',\n        camera: -1,\n        target: -1,\n        _renderer: null,\n        _scene: null,\n        _lines: new THREE.Group(),\n        _camera: null,\n        _controls: null,\n        _camerahelper: null,\n        _axishelper: null,\n        list: [],\n        clearAll: function () {\n          console.log('[TURTLE] clearAll')\n          this.disposeAllTurtle()\n          this.disposeAllLine()\n          const scene = this._scene\n          if (scene !== null) {\n            scene.remove(this._lines)\n            scene.add(this._lines)\n            if (this._camerahelper !== null) {\n              this._camerahelper.visible = false\n              scene.remove(this._camerahelper)\n              scene.add(this._camerahelper)\n            }\n            if (this._axishelper !== null) {\n              this._axishelper.visible = false\n              scene.remove(this._axishelper)\n              scene.add(this._axishelper)\n            }\n            this.initTurtle()\n          }\n        },\n        disposeAllTurtle: function () {\n          // カメをクリア\n          for (let i = 0; i < this.list.length; i++) {\n            const tt = this.list[i]\n            tt.mlist = [] // ジョブをクリア\n            // かめのモデルをカメから削除\n            this.disposeChildObject(tt.obj)\n          }\n          this.list = []\n          this.target = -1\n          this.camera = -1\n          this.flagSetTimer = false\n        },\n        disposeAllLine: function () {\n          // 引いた線を線用のバッファからクリア\n          if (this._lines !== null) {\n            this.disposeChildObject(this._lines)\n          }\n        },\n        createDefaultTurtle: function () {\n          const obj = new THREE.Group()\n\n          const material = new THREE.LineBasicMaterial({ vertexColors: true })\n\n          const vertices = new Float32Array([\n            0.0, 1.0, 0.0,\n            -0.6, -1.0, 0.0,\n            0.0, -0.5, 0.0,\n            0.6, -1.0, 0.0,\n\n            0.0, 0.0, 0.5,\n            0.0, 1.0, 0.0,\n            -0.6, -1.0, 0.0,\n            0.0, -0.5, 0.0,\n            0.6, -1.0, 0.0,\n\n            0.0, 0.0, -0.5,\n            0.0, 1.0, 0.0,\n            -0.6, -1.0, 0.0,\n            0.0, -0.5, 0.0,\n            0.6, -1.0, 0.0\n          ])\n\n          const colors = new Float32Array([\n            0.0, 1.0, 0.0,\n            0.0, 1.0, 0.0,\n            0.0, 1.0, 0.0,\n            0.0, 1.0, 0.0,\n\n            1.0, 0.0, 0.0,\n            1.0, 0.0, 0.0,\n            1.0, 0.0, 0.0,\n            1.0, 0.0, 0.0,\n            1.0, 0.0, 0.0,\n\n            0.0, 0.0, 1.0,\n            0.0, 0.0, 1.0,\n            0.0, 0.0, 1.0,\n            0.0, 0.0, 1.0,\n            0.0, 0.0, 1.0\n          ])\n\n          const indices = [\n            0, 1, 1, 2, 2, 3, 3, 0,\n            4, 5, 4, 6, 4, 7, 4, 8,\n            9, 10, 9, 11, 9, 12, 9, 13\n          ]\n\n          const geometry = new THREE.BufferGeometry()\n          geometry.setIndex(indices)\n          geometry.setAttribute('position', new THREE.BufferAttribute(vertices, 3))\n          geometry.setAttribute('color', new THREE.BufferAttribute(colors, 3))\n          geometry.computeBoundingSphere()\n\n          const lineSegments = new THREE.LineSegments(geometry, material)\n          lineSegments.scale.set(30.0, 30.0, 30.0)\n\n          obj.add(lineSegments)\n          return obj\n        },\n        createTurtle: function (modelUrl) {\n          // カメの情報を sys._turtle リストに追加\n          const id = this.list.length\n          const tt = {\n            id: id,\n            obj: new THREE.Group(),\n            home: {\n              position: new THREE.Vector3(0, 0, 0),\n              quaternion: new THREE.Quaternion()\n            },\n            color: new THREE.Color(0xffffff),\n            lineWidth: 4,\n            flagDown: true,\n            flagLoaded: false,\n            f_visible: true,\n            mlist: []\n          }\n          this.list.push(tt)\n          this.target = id\n          tt.home.position.copy(tt.obj.position)\n          tt.home.quaternion.copy(tt.obj.quaternion)\n          this.loadTurtle(tt, modelUrl)\n          const scene = this.getScene()\n          scene.add(tt.obj)\n          return id\n        },\n        loadTurtle: function (tt, url) {\n          const loader = new THREE.ObjectLoader()\n          const me = this\n          if (url instanceof THREE.Object3D) {\n            console.log('turtle.object')\n            me.disposeChildObject(tt.obj)\n            const obj = url\n            tt.obj.add(obj)\n            tt.flagLoaded = true\n            me.doDraw()\n            return\n          }\n          if (url.length === 0) {\n            console.log('turtle.default')\n            me.disposeChildObject(tt.obj)\n            const obj = me.createDefaultTurtle()\n            tt.obj.add(obj)\n            tt.flagLoaded = true\n            me.doDraw()\n            return\n          }\n          loader.load(url, function (obj) {\n            console.log('turtle.onload')\n            me.disposeChildObject(tt.obj)\n            tt.obj.add(obj)\n            tt.flagLoaded = true\n            me.doDraw()\n          }, function (xhr) {\n            // nothing\n          }, function (xhr) {\n            console.log('turtle.onerror')\n            tt.flagLoaded = true\n            tt.f_visible = false\n            tt.obj.visible = false\n            me.disposeChildObject(tt.obj)\n            me.doDraw()\n          })\n        },\n        initTurtle: function () {\n          if (this.list.length === 0) {\n            const index = this.createTurtle('')\n            const tt = this.list[index]\n            tt.obj.position.set(0, 0, 1000)\n            const axis = new THREE.Vector3(0, 0, -1).normalize()\n            const angle = 0\n            tt.obj.quaternion.setFromAxisAngle(axis, angle)\n            tt.home.position.copy(tt.obj.position)\n            tt.home.quaternion.copy(tt.obj.quaternion)\n            tt.f_visible = false\n            tt.obj.visible = false\n            this.camera = index\n            this.target = -1\n          }\n        },\n        getCur: function () {\n          if (this.list.length === 0) {\n            throw Error('最初に『T3Dカメ作成』命令を呼び出してください。')\n          }\n          if (this.target < 0 || this.target >= this.list.length) {\n            throw Error('指定された番号のカメはいません。')\n          }\n          return this.list[this.target]\n        },\n        doDraw: function () {\n          if (this.camera === -1) { return }\n          this.getRenderer()\n          const camera = this.list[this.camera]\n          if (this._controls !== null) { //\n          } else {\n            this._camera.position.copy(camera.obj.position)\n            this._camera.quaternion.copy(camera.obj.quaternion)\n          }\n          if (this._camerahelper !== null) {\n            this._camerahelper.update()\n          }\n          this._renderer.clear()\n          if (this._controls !== null) {\n            this._controls.update()\n            camera.obj.position.copy(this._camera.position)\n            camera.obj.quaternion.copy(this._camera.quaternion)\n          }\n          this._renderer.render(this._scene, this._camera)\n        },\n        setCameraHelper: function (flag) {\n          if (flag) {\n            if (this._camerahelper === null) {\n              if (typeof THREE.CameraHelper === 'undefined') {\n                throw Error('カメラヘルパの機能が見当たりません。')\n              }\n              const cameraHelper = new THREE.CameraHelper(this._camera)\n              this._camerahelper = cameraHelper\n              this._scene.add(cameraHelper)\n            }\n            this._camerahelper.visible = true\n          } else {\n            if (this._camerahelper !== null) {\n              this._camerahelper.visible = false\n            }\n          }\n        },\n        setAxisHelper: function (flag) {\n          if (flag) {\n            if (this._axishelper === null) {\n              if (typeof THREE.AxisHelper === 'undefined') {\n                throw Error('AXISヘルパの機能が見当たりません。')\n              }\n              const axisHelper = new THREE.AxisHelper(1000)\n              this._axishelper = axisHelper\n              this._scene.add(axisHelper)\n            }\n            this._axishelper.visible = true\n          } else {\n            if (this._axishelper !== null) {\n              this._axishelper.visible = false\n            }\n          }\n        },\n        getScene: function () {\n          if (this._scene === null) {\n            const scene = new THREE.Scene()\n            if (scene === null) {\n              throw new Error('シーンを作成できません')\n            }\n            this._scene = scene\n          }\n          return this._scene\n        },\n        getCamera: function () {\n          if (this._camera === null) {\n            const camera = new THREE.PerspectiveCamera(60, 1.0, 1, 65000)\n            if (camera === null) {\n              throw new Error('カメラを作成できません')\n            }\n            this.resetCamera(camera)\n            this._camera = camera\n          }\n          return this._camera\n        },\n        resetCamera: function (camera) {\n          camera.position.set(0, 0, 1000)\n          if (this._renderer !== null) {\n            const rect = new THREE.Vector2()\n            this._renderer.getSize(rect)\n            camera.aspect = rect.width / rect.height\n          }\n          camera.up = new THREE.Vector3(0, 1, 0)\n          camera.lookAt(new THREE.Vector3(0, 0, 0))\n        },\n        initTrutle3dEnv: function (renderer) {\n          renderer.setClearColor(0x000000, 1.0)\n          renderer.autoClear = false\n\n          const scene = this.getScene()\n          // eslint-disable-next-line no-unused-vars\n          const camera = this.getCamera()\n\n          scene.add(sys._weykturtle3d._lines)\n          if (this.list.length === 0) {\n            this.initTurtle()\n          }\n        },\n        initRenderer: function () {\n          // 描画先をセットする\n          let to = sys.__v0['T3Dカメ描画先']\n          if (typeof to === 'string') { to = document.querySelector(to) || document.getElementById(to) }\n          if (!to) {\n            throw new Error('[ERROR] T3Dカメ描画先が見当たりません。')\n          }\n          this.setRenderer(to)\n        },\n        setRenderer: function (to) {\n          if (to instanceof THREE.WebGLRenderer) {\n            this._renderer = to\n          } else {\n            const renderer = new THREE.WebGLRenderer({ antialias: false, alpha: true })\n            if (renderer === null) {\n              throw new Error('レンダラを作成できません')\n            }\n            renderer.setPixelRatio(window.devicePixelRatio)\n            renderer.setSize(to.clientWidth, to.clientHeight)\n            to.appendChild(renderer.domElement)\n            this._renderer = renderer\n          }\n          return this._renderer\n        },\n        setupRenderer: function () {\n          this.initTrutle3dEnv(this._renderer)\n        },\n        getRenderer: function () {\n          if (this._renderer === null) {\n            this.initRenderer()\n            this.setupRenderer()\n          }\n          return this._renderer\n        },\n        setupControl: function (controlConstrucor) {\n          if (typeof controlConstrucor === 'undefined') {\n            throw new Error('指定されたコンコントロールが見当たりません。')\n          }\n          if (this._controls !== null) {\n            if (this._controls instanceof controlConstrucor) {\n              return this._controls\n            } else {\n              throw new Error('既にコントロールを適用しています。コントロールの変更はできません。')\n            }\n          }\n          const renderer = this.getRenderer()\n          const camera = this.getCamera(renderer)\n          // eslint-disable-next-line new-cap\n          const controls = new controlConstrucor(camera, renderer.domElement)\n          controls.enabled = true\n          this._controls = controls\n          return this._controls\n        },\n        line: function (tt, v1, v2) {\n          if (tt) {\n            if (!tt.flagDown) { return }\n          }\n          const geometry = new THREE.BufferGeometry()\n          const vertices = new THREE.Float32BufferAttribute(6, 3)\n          vertices.copyVector3sArray([v1, v2])\n          const material = new THREE.LineBasicMaterial({ color: tt.color, linewidth: tt.lineWidth })\n          geometry.setAttribute('position', vertices)\n          const line = new THREE.Line(geometry, material)\n          this._lines.add(line)\n        },\n        doMacro: function (tt, wait) {\n          const me = this\n          if (!tt.flagLoaded && wait > 0) {\n            console.log('[TURTLE] waiting ...')\n            return true\n          }\n          const m = tt.mlist.shift()\n          const cmd = (m !== undefined) ? m[0] : ''\n          switch (cmd) {\n            case 'xyz':\n              // 起点を移動する\n              tt.obj.position.copy(m[1])\n              break\n            case 'mv': {\n              const v1 = tt.obj.position.clone()\n              const v2 = m[1]\n              // 線を引く\n              this.line(tt, v1, v2)\n              // カメの角度を変更\n              tt.obj.lookAt(v2)\n              const headup90 = new THREE.Quaternion()\n              const axisX = new THREE.Vector3(1, 0, 0)\n              headup90.setFromAxisAngle(axisX, Math.PI / 2)\n              tt.obj.quaternion.multiply(headup90)\n              // カメを移動\n              tt.obj.position.copy(v2)\n              break\n            }\n            case 'fd': {\n              const v1 = tt.obj.position.clone()\n              const v2 = new THREE.Vector3(0, m[1] * m[2], 0)\n              v2.applyQuaternion(tt.obj.quaternion)\n              v2.add(v1)\n              this.line(tt, v1, v2)\n              tt.obj.position.copy(v2)\n              break\n            }\n            case 'su': {\n              const v1 = tt.obj.position.clone()\n              const v2 = new THREE.Vector3(0, m[1], 0)\n              const modifier = new THREE.Quaternion()\n              const axis = new THREE.Vector3(1, 0, 0)\n              modifier.setFromAxisAngle(axis, (-90) * Math.PI / 180)\n              const target = tt.obj.quaternion.clone()\n              target.multiply(modifier)\n              v2.applyQuaternion(target)\n              v2.add(v1)\n              this.line(tt, v1, v2)\n              tt.obj.position.copy(v2)\n              break\n            }\n            case 'sd': {\n              const v1 = tt.obj.position.clone()\n              const v2 = new THREE.Vector3(0, m[1], 0)\n              const modifier = new THREE.Quaternion()\n              const axis = new THREE.Vector3(1, 0, 0)\n              modifier.setFromAxisAngle(axis, 90 * Math.PI / 180)\n              const target = tt.obj.quaternion.clone()\n              target.multiply(modifier)\n              v2.applyQuaternion(target)\n              v2.add(v1)\n              this.line(tt, v1, v2)\n              tt.obj.position.copy(v2)\n              break\n            }\n            case 'sl': {\n              const v1 = tt.obj.position.clone()\n              const v2 = new THREE.Vector3(0, m[1], 0)\n              const modifier = new THREE.Quaternion()\n              const axis = new THREE.Vector3(0, 0, 1)\n              modifier.setFromAxisAngle(axis, 90 * Math.PI / 180)\n              const target = tt.obj.quaternion.clone()\n              target.multiply(modifier)\n              v2.applyQuaternion(target)\n              v2.add(v1)\n              this.line(tt, v1, v2)\n              tt.obj.position.copy(v2)\n              break\n            }\n            case 'sr': {\n              const v1 = tt.obj.position.clone()\n              const v2 = new THREE.Vector3(0, m[1], 0)\n              const modifier = new THREE.Quaternion()\n              const axis = new THREE.Vector3(0, 0, 1)\n              modifier.setFromAxisAngle(axis, (-90) * Math.PI / 180)\n              const target = tt.obj.quaternion.clone()\n              target.multiply(modifier)\n              v2.applyQuaternion(target)\n              v2.add(v1)\n              this.line(tt, v1, v2)\n              tt.obj.position.copy(v2)\n              break\n            }\n            case 'angle': {\n              const euler = new THREE.Euler()\n              euler.fromArray(m[1])\n              // eslint-disable-next-line no-unused-vars\n              const dir = new THREE.Quaternion()\n              tt.obj.quaternion.setFromEuler(euler)\n              break\n            }\n            case 'rotr': {\n              const rv = m[1]\n              const target = new THREE.Quaternion()\n              const axis = new THREE.Vector3(0, 0, 1)\n              target.setFromAxisAngle(axis, (-rv % 360) * Math.PI / 180)\n              tt.obj.quaternion.multiply(target)\n              break\n            }\n            case 'rotl': {\n              const rv = m[1]\n              const target = new THREE.Quaternion()\n              const axis = new THREE.Vector3(0, 0, 1)\n              target.setFromAxisAngle(axis, (rv % 360) * Math.PI / 180)\n              tt.obj.quaternion.multiply(target)\n              break\n            }\n            case 'rotu': {\n              const rv = m[1]\n              const target = new THREE.Quaternion()\n              const axis = new THREE.Vector3(1, 0, 0)\n              target.setFromAxisAngle(axis, (-rv % 360) * Math.PI / 180)\n              tt.obj.quaternion.multiply(target)\n              break\n            }\n            case 'rotd': {\n              const rv = m[1]\n              const target = new THREE.Quaternion()\n              const axis = new THREE.Vector3(1, 0, 0)\n              target.setFromAxisAngle(axis, (rv % 360) * Math.PI / 180)\n              tt.obj.quaternion.multiply(target)\n              break\n            }\n            case 'rolr': {\n              const rv = m[1]\n              const target = new THREE.Quaternion()\n              const axis = new THREE.Vector3(0, 1, 0)\n              target.setFromAxisAngle(axis, (rv % 360) * Math.PI / 180)\n              tt.obj.quaternion.multiply(target)\n              break\n            }\n            case 'roll': {\n              const rv = m[1]\n              const target = new THREE.Quaternion()\n              const axis = new THREE.Vector3(0, 1, 0)\n              target.setFromAxisAngle(axis, (-rv % 360) * Math.PI / 180)\n              tt.obj.quaternion.multiply(target)\n              break\n            }\n            case 'color':\n              tt.color = new m[1]()\n              break\n            case 'size':\n              tt.lineWidth = m[1]\n              break\n            case 'penOn':\n              tt.flagDown = m[1]\n              break\n            case 'visible':\n              tt.f_visible = m[1]\n              if (tt.f_visible) {\n                tt.obj.visible = true\n              } else {\n                tt.obj.visible = false\n              }\n              break\n            case 'changeModel':\n              tt.flagLoaded = false\n              me.loadTurtle(tt, m[1])\n              break\n            case 'changeCamera':\n              me.camera = m[1]\n              break\n            case 'sethome':\n              tt.home.position.copy(tt.obj.position)\n              tt.home.quaternion.copy(tt.obj.quaternion)\n              break\n            case 'gohome':\n              tt.obj.position.copy(tt.home.position)\n              tt.obj.quaternion.copy(tt.home.quaternion)\n              break\n          }\n          return (tt.mlist.length > 0)\n        },\n        doMacroAll: function (wait) {\n          let hasNext = false\n          for (let i = 0; i < this.list.length; i++) {\n            const tt = this.list[i]\n            if (this.doMacro(tt, wait)) { hasNext = true }\n          }\n          return hasNext\n        },\n        flagSetTimer: false,\n        animationStart: function () {\n          const wait = this.getWait()\n          if (wait === 0) {\n            this.animation()\n            return\n          }\n          if (this.flagSetTimer) { return }\n          this.flagSetTimer = true\n          this.animationFrame(this.animation)\n        },\n        getWait: function () {\n          return sys.__v0['T3Dカメ速度']\n        },\n        disposeChildObject: function (obj) {\n          while (obj.children.length > 0) {\n            this.disposeChildObject(obj.children[0])\n            obj.remove(obj.children[0])\n          }\n          if (obj.geometry) { obj.geometry.dispose() }\n\n          if (obj.material) {\n            Object.keys(obj.material).forEach(prop => {\n              if (!obj.material[prop]) { return }\n              if (typeof obj.material[prop].dispose === 'function') { obj.material[prop].dispose() }\n            })\n            obj.material.dispose()\n          }\n        },\n        animation: function () {\n          const me = sys._weykturtle3d\n          const now = Date.now()\n          const elapsedMs = now - me._prevUpdatedTime\n          const wait = me.getWait()\n          if (wait > 0 && elapsedMs < wait) {\n            me.doDraw()\n            me.animationFrame(me.animation)\n            return\n          }\n          let hasNext = me.doMacroAll(wait)\n          if (wait <= 0) {\n            while (hasNext) {\n              hasNext = me.doMacroAll(wait)\n            }\n          } else if (hasNext || me._controls !== null) {\n            me.doDraw()\n            me._prevUpdatedTime = now\n            me.animationFrame(me.animation)\n            return\n          }\n          me.doDraw()\n          me.flagSetTimer = false\n        }\n      }\n      sys._weykturtle3d.animationFrame = (function () {\n        return function (callback, element) {\n          window.setTimeout(callback, 1000 / 60)\n        }\n        /* window.requestAnimationFrame       ||\n                   window.webkitRequestAnimationFrame ||\n                   window.mozRequestAnimationFrame    ||\n                   window.oRequestAnimationFrame      ||\n                   window.msRequestAnimationFrame     || */\n      })()\n    }\n  },\n  // @3Dタートルグラフィックス/カメ操作\n  'T3Dカメ作成': { // @タートルグラフィックスを開始してカメのIDを返す // @T3Dかめさくせい\n    type: 'func',\n    josi: [],\n    pure: true,\n    fn: function (sys) {\n      if (!sys._weykturtle3d) { return null }\n      sys._weykturtle3d.initTurtle()\n      const modelUrl = sys.__v0['T3DカメモデルURL']\n      const id = sys._weykturtle3d.createTurtle(modelUrl)\n      return id\n    },\n    return_none: false\n  },\n  'T3Dカメ操作対象設定': { // @IDを指定して操作対象となるカメを変更する // @T3Dかめそうさたいしょうせってい\n    type: 'func',\n    josi: [['に', 'へ', 'の']],\n    pure: true,\n    fn: function (id, sys) {\n      if (!sys._weykturtle3d) { return null }\n      sys._weykturtle3d.target = id\n    },\n    return_none: true\n  },\n  'T3Dカメ描画先': { type: 'var', value: 'turtle3d_div' }, // @T3Dかめびょうがさき\n  'T3DカメモデルURL': { type: 'var', value: '' }, // @T3DかめもでるURL\n  'T3Dカメモデル変更': { // @カメのモデルをURLに変更する // @T3Dかめもでるへんこう\n    type: 'func',\n    josi: [['に', 'へ']],\n    pure: true,\n    fn: function (url, sys) {\n      if (!sys._weykturtle3d) { return null }\n      const tt = sys._weykturtle3d.getCur()\n      tt.mlist.push(['changeModel', url])\n      sys._weykturtle3d.animationStart()\n    },\n    return_none: true\n  },\n  'T3Dカメ速度': { type: 'const', value: 100 }, // @T3Dかめそくど\n  'T3Dカメ速度設定': { // @カメの動作速度vに設定(大きいほど遅い) // @T3Dかめそくどせってい\n    type: 'func',\n    josi: [['に', 'へ']],\n    pure: true,\n    fn: function (v, sys) {\n      sys.__varslist[0]['T3Dカメ速度'] = v\n    },\n    return_none: true\n  },\n  'T3Dカメ移動': { // @カメの位置を[x,y,z]へ移動する // @T3Dかめいどう\n    type: 'func',\n    josi: [['に', 'へ']],\n    pure: true,\n    fn: function (xyz, sys) {\n      if (!sys._weykturtle3d) { return null }\n      const tt = sys._weykturtle3d.getCur()\n      tt.mlist.push(['mv', new THREE.Vector3(xyz[0], xyz[1], xyz[2])])\n      sys._weykturtle3d.animationStart()\n    },\n    return_none: true\n  },\n  'T3Dカメ原点設定': { // @カメの原点を現在の位置・向きに設定する // @T3Dかめげんてんせってい\n    type: 'func',\n    josi: [],\n    pure: true,\n    fn: function (sys) {\n      if (!sys._weykturtle3d) { return null }\n      const tt = sys._weykturtle3d.getCur()\n      tt.mlist.push(['sethome'])\n      sys._weykturtle3d.animationStart()\n    },\n    return_none: true\n  },\n  'T3Dカメ原点移動': { // @カメを原点の位置・向きに移動する(描画はしない) // @T3Dかめげんてんいどう\n    type: 'func',\n    josi: [],\n    pure: true,\n    fn: function (sys) {\n      if (!sys._weykturtle3d) { return null }\n      const tt = sys._weykturtle3d.getCur()\n      tt.mlist.push(['gohome'])\n      sys._weykturtle3d.animationStart()\n    },\n    return_none: true\n  },\n  'T3Dカメ起点移動': { // @カメの描画起点位置を[x,y,z]へ移動する // @T3Dかめきてんいどう\n    type: 'func',\n    josi: [['に', 'へ']],\n    pure: true,\n    fn: function (xyz, sys) {\n      if (!sys._weykturtle3d) { return null }\n      const tt = sys._weykturtle3d.getCur()\n      tt.mlist.push(['xyz', new THREE.Vector3(xyz[0], xyz[1], xyz[2])])\n      sys._weykturtle3d.animationStart()\n    },\n    return_none: true\n  },\n  'T3Dカメ進': { // @カメの位置をVだけ進める // @T3Dかめすすむ\n    type: 'func',\n    josi: [['だけ']],\n    pure: true,\n    fn: function (v, sys) {\n      if (!sys._weykturtle3d) { return null }\n      const tt = sys._weykturtle3d.getCur()\n      tt.mlist.push(['fd', v, 1])\n      sys._weykturtle3d.animationStart()\n    },\n    return_none: true\n  },\n  'T3Dカメ戻': { // @カメの位置をVだけ戻す // @T3Dかめもどる\n    type: 'func',\n    josi: [['だけ']],\n    pure: true,\n    fn: function (v, sys) {\n      if (!sys._weykturtle3d) { return null }\n      const tt = sys._weykturtle3d.getCur()\n      tt.mlist.push(['fd', v, -1])\n      sys._weykturtle3d.animationStart()\n    },\n    return_none: true\n  },\n  'T3Dカメ上平行移動': { // @カメの位置を上にVだけ進める // @T3Dかめうえへいこういどう\n    type: 'func',\n    josi: [['だけ']],\n    pure: true,\n    fn: function (v, sys) {\n      if (!sys._weykturtle3d) { return null }\n      const tt = sys._weykturtle3d.getCur()\n      tt.mlist.push(['su', v])\n      sys._weykturtle3d.animationStart()\n    },\n    return_none: true\n  },\n  'T3Dカメ下平行移動': { // @カメの位置を下にVだけ進める // @T3Dかめしたへいこういどう\n    type: 'func',\n    josi: [['だけ']],\n    pure: true,\n    fn: function (v, sys) {\n      if (!sys._weykturtle3d) { return null }\n      const tt = sys._weykturtle3d.getCur()\n      tt.mlist.push(['sd', v])\n      sys._weykturtle3d.animationStart()\n    },\n    return_none: true\n  },\n  'T3Dカメ左平行移動': { // @カメの位置を左にVだけ進める // @T3Dかめひだりへいこういどう\n    type: 'func',\n    josi: [['だけ']],\n    pure: true,\n    fn: function (v, sys) {\n      if (!sys._weykturtle3d) { return null }\n      const tt = sys._weykturtle3d.getCur()\n      tt.mlist.push(['sl', v])\n      sys._weykturtle3d.animationStart()\n    },\n    return_none: true\n  },\n  'T3Dカメ右平行移動': { // @カメの位置を右にVだけ進める // @T3Dかめみぎへいこういどう\n    type: 'func',\n    josi: [['だけ']],\n    pure: true,\n    fn: function (v, sys) {\n      if (!sys._weykturtle3d) { return null }\n      const tt = sys._weykturtle3d.getCur()\n      tt.mlist.push(['sr', v])\n      sys._weykturtle3d.animationStart()\n    },\n    return_none: true\n  },\n  'T3Dカメ動': { // @カメの位置をDIRにVだけ進める // @T3Dかめうごく\n    type: 'func',\n    josi: [['へ', 'に'], ['だけ']],\n    pure: true,\n    fn: function (dir, v, sys) {\n      if (!sys._weykturtle3d) { return null }\n      const tt = sys._weykturtle3d.getCur()\n      let cmd = ''\n      if (dir === '前' || dir === '後') {\n        if (dir === '前') {\n          tt.mlist.push(['fd', v, 1])\n        } else {\n          tt.mlist.push(['fd', v, -1])\n        }\n      } else {\n        if (dir === '上' || dir === 'UP' || dir === 'うえ') {\n          cmd = 'su'\n        } else\n        if (dir === '下' || dir === 'DOWN' || dir === 'した') {\n          cmd = 'sd'\n        } else\n        if (dir === '右' || dir === 'RIGHT' || dir === 'みぎ') {\n          cmd = 'sr'\n        } else\n        if (dir === '左' || dir === 'LEFT' || dir === 'ひだり') {\n          cmd = 'sl'\n        } else {\n          throw Error('方向の指定が正しくありません。前後上下左右のいずれかで指定してください。')\n        }\n        tt.mlist.push([cmd, v])\n      }\n      sys._weykturtle3d.animationStart()\n    },\n    return_none: true\n  },\n  'T3Dカメ角度設定': { // @カメの向きをオイラー(XYZ)にて設定する // @T3Dかめかくどせってい\n    type: 'func',\n    josi: [['に', 'へ', 'の']],\n    pure: true,\n    fn: function (v, sys) {\n      if (!sys._weykturtle3d) { return null }\n      const tt = sys._weykturtle3d.getCur()\n      tt.mlist.push(['angle', parseFloat(v)])\n      sys._weykturtle3d.animationStart()\n    },\n    return_none: true\n  },\n  'T3Dカメ右回転': { // @カメの向きをDEGだけ右に向ける // @T3Dかめみぎかいてん\n    type: 'func',\n    josi: [['だけ']],\n    pure: true,\n    fn: function (v, sys) {\n      if (!sys._weykturtle3d) { return null }\n      const tt = sys._weykturtle3d.getCur()\n      tt.mlist.push(['rotr', v])\n      sys._weykturtle3d.animationStart()\n    },\n    return_none: true\n  },\n  'T3Dカメ左回転': { // @カメの向きをDEGだけ左に向ける // @T3Dかめひだりかいてん\n    type: 'func',\n    josi: [['だけ']],\n    pure: true,\n    fn: function (v, sys) {\n      if (!sys._weykturtle3d) { return null }\n      const tt = sys._weykturtle3d.getCur()\n      tt.mlist.push(['rotl', v])\n      sys._weykturtle3d.animationStart()\n    },\n    return_none: true\n  },\n  'T3Dカメ上回転': { // @カメの向きをDEGだけ上に向ける // @T3Dかめうえかいてん\n    type: 'func',\n    josi: [['だけ']],\n    pure: true,\n    fn: function (v, sys) {\n      if (!sys._weykturtle3d) { return null }\n      const tt = sys._weykturtle3d.getCur()\n      tt.mlist.push(['rotu', v])\n      sys._weykturtle3d.animationStart()\n    },\n    return_none: true\n  },\n  'T3Dカメ下回転': { // @カメの向きをDEGだけ下に向ける // @T3Dかめしたかいてん\n    type: 'func',\n    josi: [['だけ']],\n    pure: true,\n    fn: function (v, sys) {\n      if (!sys._weykturtle3d) { return null }\n      const tt = sys._weykturtle3d.getCur()\n      tt.mlist.push(['rotd', v])\n      sys._weykturtle3d.animationStart()\n    },\n    return_none: true\n  },\n  'T3Dカメ回転': { // @カメの向きをDEGだけDIRに向ける // @T3Dかめかいてん\n    type: 'func',\n    josi: [['へ', 'に'], ['だけ']],\n    pure: true,\n    fn: function (dir, v, sys) {\n      if (!sys._weykturtle3d) { return null }\n      const tt = sys._weykturtle3d.getCur()\n      let cmd = ''\n      if (dir === '上' || dir === 'UP' || dir === 'うえ') {\n        cmd = 'rotu'\n      } else\n      if (dir === '下' || dir === 'DOWN' || dir === 'した') {\n        cmd = 'rotd'\n      } else\n      if (dir === '右' || dir === 'RIGHT' || dir === 'みぎ') {\n        cmd = 'rotr'\n      } else\n      if (dir === '左' || dir === 'LEFT' || dir === 'ひだり') {\n        cmd = 'rotl'\n      } else {\n        throw Error('方向の指定が正しくありません。上下左右のいずれかで指定してください。')\n      }\n      tt.mlist.push([cmd, v])\n      sys._weykturtle3d.animationStart()\n    },\n    return_none: true\n  },\n  'T3Dカメ右ロール': { // @カメをDEGだけ右に傾ける // @T3Dかめみぎろーる\n    type: 'func',\n    josi: [['だけ']],\n    pure: true,\n    fn: function (v, sys) {\n      if (!sys._weykturtle3d) { return null }\n      const tt = sys._weykturtle3d.getCur()\n      tt.mlist.push(['rolr', v])\n      sys._weykturtle3d.animationStart()\n    },\n    return_none: true\n  },\n  'T3Dカメ左ロール': { // @カメのDEGだけ左に傾ける // @T3Dかめひだりろーる\n    type: 'func',\n    josi: [['だけ']],\n    pure: true,\n    fn: function (v, sys) {\n      if (!sys._weykturtle3d) { return null }\n      const tt = sys._weykturtle3d.getCur()\n      tt.mlist.push(['roll', v])\n      sys._weykturtle3d.animationStart()\n    },\n    return_none: true\n  },\n  'T3Dカメ傾': { // @カメをDEGだけDIRに傾ける // @T3Dかめかたむける\n    type: 'func',\n    josi: [['に', 'へ'], ['だけ']],\n    pure: true,\n    fn: function (dir, v, sys) {\n      if (!sys._weykturtle3d) { return null }\n      const tt = sys._weykturtle3d.getCur()\n      let cmd = ''\n      if (dir === '右' || dir === 'RIGHT' || dir === 'みぎ') {\n        cmd = 'rolr'\n      } else\n      if (dir === '左' || dir === 'LEFT' || dir === 'ひだり') {\n        cmd = 'roll'\n      } else {\n        throw Error('向きの指定が正しくありません。左右のどちらかで指定してください。')\n      }\n      tt.mlist.push([cmd, v])\n      sys._weykturtle3d.animationStart()\n    },\n    return_none: true\n  },\n  'T3Dカメペン色設定': { // @カメのペン描画色をCに設定する // @T3Dかめぺんいろせってい\n    type: 'func',\n    josi: [['に', 'へ']],\n    pure: true,\n    fn: function (c, sys) {\n      if (!sys._weykturtle3d) { return null }\n      const tt = sys._weykturtle3d.getCur()\n      tt.mlist.push(['color', c])\n      sys._weykturtle3d.animationStart()\n    },\n    return_none: true\n  },\n  'T3Dカメペンサイズ設定': { // @カメペンのサイズをWに設定する // @T3Dかめぺんさいずせってい\n    type: 'func',\n    josi: [['に', 'へ']],\n    pure: true,\n    fn: function (w, sys) {\n      if (!sys._weykturtle3d) { return null }\n      const tt = sys._weykturtle3d.getCur()\n      tt.mlist.push(['size', w])\n      sys._weykturtle3d.animationStart()\n    },\n    return_none: true\n  },\n  'T3Dカメペン設定': { // @カメペンを使うかどうかをV(オン/オフ)に設定する // @T3Dかめぺんせってい\n    type: 'func',\n    josi: [['に', 'へ']],\n    pure: true,\n    fn: function (w, sys) {\n      if (!sys._weykturtle3d) { return null }\n      const tt = sys._weykturtle3d.getCur()\n      tt.mlist.push(['penOn', w])\n      sys._weykturtle3d.animationStart()\n    },\n    return_none: true\n  },\n  'T3Dカメ全消去': { // @表示しているカメと描画内容を全部消去する // @T3Dかめぜんしょうきょ\n    type: 'func',\n    josi: [],\n    pure: true,\n    fn: function (sys) {\n      if (!sys._weykturtle3d) { return null }\n      sys._weykturtle3d.clearAll()\n    },\n    return_none: true\n  },\n  'T3Dカメ非表示': { // @カメのモデルを非表示にする。描画に影響しない。 // @T3Dかめひひょうじ\n    type: 'func',\n    josi: [],\n    pure: true,\n    fn: function (sys) {\n      if (!sys._weykturtle3d) { return null }\n      const tt = sys._weykturtle3d.getCur()\n      tt.mlist.push(['visible', false])\n      sys._weykturtle3d.animationStart()\n    },\n    return_none: true\n  },\n  'T3Dカメ表示': { // @非表示にしたカメのモデルを表示する。 // @T3Dかめひょうじ\n    type: 'func',\n    josi: [],\n    pure: true,\n    fn: function (sys) {\n      if (!sys._weykturtle3d) { return null }\n      const tt = sys._weykturtle3d.getCur()\n      tt.mlist.push(['visible', true])\n      sys._weykturtle3d.animationStart()\n    },\n    return_none: true\n  },\n  'T3D視点カメ設定': { // @指定したカメを視点として使用する // @T3Dしてんかめせってい\n    type: 'func',\n    josi: [['に', 'へ']],\n    pure: true,\n    fn: function (w, sys) {\n      if (!sys._weykturtle3d) { return null }\n      if (w < 0 || w >= sys._weykturtle3d.list.length) {\n        throw Error('指定された番号のカメはいません。')\n      }\n      const tt = sys._weykturtle3d.getCur()\n      tt.mlist.push(['changeCamera', w])\n      sys._weykturtle3d.animationStart()\n    },\n    return_none: true\n  },\n  // @3Dタートルグラフィックス/基本機能\n  'T3D描画準備': { // @指定したDOMのIDに対する描画を準備し、描画オブジェクトを返す // @T3Dびょうがじゅんび\n    type: 'func',\n    josi: [['に', 'へ']],\n    pure: true,\n    fn: function (to, sys) {\n      if (!sys._weykturtle3d) { return null }\n      if (typeof THREE === 'undefined') {\n        throw new Error('three.jsが読み込まれていません')\n      }\n\n      if (typeof to === 'string') { to = document.querySelector(to) || document.getElementById(to) }\n      if (!to) { throw new Error('TJS描画準備に指定した描画先に誤りがあります') }\n\n      sys._weykturtle3d.setRenderer(to)\n      sys._weykturtle3d.setupRenderer()\n      return sys._weykturtle3d._renderer\n    },\n    return_none: false\n  },\n  'T3D描画': { // @現在の状態を描画する // @T3Dびょうが\n    type: 'func',\n    josi: [],\n    pure: true,\n    fn: function (sys) {\n      if (!sys._weykturtle3d) { return null }\n      sys._weykturtle3d.doDraw()\n    },\n    return_none: true\n  },\n  'T3D背景色設定': { // @canvasをクリアする際の背景色を設定する // @T3Dはいけいしょくせってい\n    type: 'func',\n    josi: [['に', 'へ']],\n    pure: true,\n    fn: function (c, sys) {\n      if (!sys._weykturtle3d) { return null }\n      if (sys._weykturtle3d._renderer === null) {\n        sys._weykturtle3d.setRenderTarget()\n      }\n      sys._weykturtle3d._renderer.setClearColor(c)\n      sys._weykturtle3d.animationStart()\n    },\n    return_none: true\n  },\n  'T3D背景透過設定': { // @canvasをクリアする際の背景のアルファ値を設定する // @T3Dはいけいとうかせってい\n    type: 'func',\n    josi: [['に', 'へ']],\n    pure: true,\n    fn: function (c, sys) {\n      if (!sys._weykturtle3d) { return null }\n      if (sys._weykturtle3d._renderer === null) {\n        sys._weykturtle3d.setRenderTarget()\n      }\n      sys._weykturtle3d._renderer.setClearAlpha(c)\n      sys._weykturtle3d.animationStart()\n    },\n    return_none: true\n  },\n  'T3DJSON取得': { // @描画した線のJSON形式で取得する // @T3DJSONしゅとく\n    type: 'func',\n    josi: [],\n    pure: true,\n    fn: function (sys) {\n      if (!sys._weykturtle3d) { return null }\n      return JSON.stringify(sys._weykturtle3d._lines.toJSON())\n    },\n    return_none: false\n  },\n  // @3Dタートルグラフィックス/ヘルパ機能\n  'T3Dオービットコントロール設定': { // オービットコントロールを組み込む // @T3Dおーびっとこんとろーるせってい\n    type: 'func',\n    josi: [],\n    pure: true,\n    fn: function (sys) {\n      if (!sys._weykturtle3d) { return null }\n      if (typeof THREE.OrbitControls !== 'undefined') {\n        return sys._weykturtle3d.setupControl(THREE.OrbitControls)\n      }\n      return null\n    },\n    return_none: false\n  },\n  'T3Dコントロール有効': { // @組み込んだコントロールを有効にする // @T3Dこんとろーるゆうこう\n    type: 'func',\n    josi: [],\n    pure: true,\n    fn: function (sys) {\n      if (!sys._weykturtle3d) { return null }\n      if (sys._weykturtle3d._controls) {\n        sys._weykturtle3d._controls.enabled = true\n      }\n    },\n    return_none: true\n  },\n  'T3Dコントロール無効': { // @組み込んだコントロールを無効にする // @T3Dこんとろーるむこう\n    type: 'func',\n    josi: [],\n    pure: true,\n    fn: function (sys) {\n      if (!sys._weykturtle3d) { return null }\n      if (sys._weykturtle3d._controls) {\n        sys._weykturtle3d._controls.enabled = false\n      }\n    },\n    return_none: true\n  },\n  'T3Dカメラヘルパ表示': { // @カメラヘルパーを表示する // @T3Dかめらへるぱひょうじ\n    type: 'func',\n    josi: [],\n    pure: true,\n    fn: function (sys) {\n      if (!sys._weykturtle3d) { return null }\n      sys._weykturtle3d.setCameraHelper(true)\n    },\n    return_none: true\n  },\n  'T3Dカメラヘルパ非表示': { // @カメラヘルパーを非表示にする // @T3Dかめらへるぱひひょうじ\n    type: 'func',\n    josi: [],\n    pure: true,\n    fn: function (sys) {\n      if (!sys._weykturtle3d) { return null }\n      sys._weykturtle3d.setCameraHelper(false)\n    },\n    return_none: true\n  },\n  'T3D軸線ヘルパ表示': { // @座標軸ヘルパーを表示する // @T3Dじくせんへるぱひょうじ\n    type: 'func',\n    josi: [],\n    pure: true,\n    fn: function (sys) {\n      if (!sys._weykturtle3d) { return null }\n      sys._weykturtle3d.setAxisHelper(true)\n    },\n    return_none: true\n  },\n  'T3D軸線ヘルパ非表示': { // @座標軸ヘルパーを非表示にする // @T3Dじくせんへるぱひひょうじ\n    type: 'func',\n    josi: [],\n    pure: true,\n    fn: function (sys) {\n      if (!sys._weykturtle3d) { return null }\n      sys._weykturtle3d.setAxisHelper(false)\n    },\n    return_none: true\n  }\n}\n\n/* harmony default export */ __webpack_exports__[\"default\"] = (PluginWeykTurtle3D);\n\n// ブラウザからscriptタグで取り込んだ時、自動で登録する\nif (typeof (navigator) === 'object') {\n  navigator.nako3.addPluginObject('PluginWeykTurtle3D', PluginWeykTurtle3D)\n}\n\n\n//# sourceURL=webpack://nadesiko3/./src/plugin_weykturtle3d.mjs?")}},__webpack_require__={r:function(n){"undefined"!=typeof Symbol&&Symbol.toStringTag&&Object.defineProperty(n,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(n,"__esModule",{value:!0})}},__webpack_exports__={};__webpack_modules__["./src/plugin_weykturtle3d.mjs"](0,__webpack_exports__,__webpack_require__)})();